=== debian/changelog ===
freespace2-launcher-wxlauncher (0.12.0~rc3+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * fix build with CMake 4 (Closes: #1113667)

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 27 Sep 2025 21:35:29 +0200

freespace2-launcher-wxlauncher (0.12.0~rc3+dfsg-1) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * New upstream pre-release.
  * d/watch: corrected/updated for GitHub changes.
  * Rules-Requires-Root: no
  * rules: removed explicit "-Wl,--as-needed" LDFLAGS.

  [ Alexandre Detiste ]
  * Drop custom source compression.
  * Bump debhelper from old 11 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.6.2, no changes needed.
  * lintian-brush: add upstream/metadata
  * remove old ref. to Python2

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 28 Dec 2023 22:41:59 +1100
